#!/usr/bin/python

from utils import isdir
acllist = []
try:
    from perm_acl_config import *
except:
    pass

from Tkinter import *
import string, pprint, os, StringIO
import tkSimpleDialog, tkMessageBox, tkFileDialog, FileDialog

import TkinterConfigList

config_file = "auth_cwd_config.py"

class PermDialog(tkSimpleDialog.Dialog):

    def __init__(self, parent, title = None, initval=("", "", "", "", [], [])):

        self.initval = initval

        Toplevel.__init__(self, parent)
        self.transient(parent)

        if title:
            self.title(title)

        self.parent = parent

        self.result = None

        body = Frame(self)
        self.initial_focus = self.body(body)
        body.pack(padx=5, pady=5)

        self.buttonbox()

        self.grab_set()

        if not self.initial_focus:
            self.initial_focus = self

        self.protocol("WM_DELETE_WINDOW", self.cancel)

        self.geometry("+%d+%d" % (parent.winfo_rootx()+50,
                                  parent.winfo_rooty()+50))

        self.initial_focus.focus_set()

        self.wait_window(self)

    def body(self, master):
        Label(master, text="User:").grid(row=0, sticky=W)
        Label(master, text="Group:").grid(row=1, sticky=W)
        Label(master, text="From IP:").grid(row=2, sticky=W)

        self.euser = Entry(master, width=20)
        self.egroup = Entry(master, width=20)
        self.eip = Entry(master, width=20)

        self.euser.insert(0,self.initval[0])
        self.egroup.insert(0,self.initval[1])
        self.eip.insert(0,self.initval[2])

        self.euser.grid(row=0, column=1, sticky=W)
        self.egroup.grid(row=1, column=1, sticky=W)
        self.eip.grid(row=2, column=1, sticky=W)


        self.pathb = Button(master, 
                        text="path:", 
                        relief=FLAT,
                        command=self.pickpath)
        self.pathb.grid(row=3, sticky=W)

        self.pathv = StringVar()
        self.pathv.set(self.initval[3])
        self.epathb = Button(master, 
                        textvariable=self.pathv,
                        #relief=FLAT,
                        command=self.pickpath)
        self.epathb.grid(row=3, column=1, columnspan=2, sticky=W)


        Label(master, text="Allow these commands:").grid(row=4, sticky=W, columnspan=2)
        
        LIST = ["cwd", "list", "nlst"]
        GET = ["retr", "size", "mdtm"]
        READ = LIST+GET

        PUT = ["stor", "appe", "mkd"]
        DELETE = ["dele", "rmd"]
        
        WRITE = PUT+DELETE
        ALL = READ+WRITE
        

        keys = ALL
        allowed = {}
        for i in range(len(keys)):
            v = IntVar()
            c = Checkbutton(master,
                            text=keys[i],
                            anchor=W,
                            variable=v,
                            indicatoron=1)
            c.grid(row=i/2+6, column=i%2, sticky=W)
            v.set(keys[i] in self.initval[4])
            #v.set(1)
            print keys[i],v.get(), v
            allowed[keys[i]] = c, v
        print allowed

        lastrow = len(keys)/2+7
        Label(master, text="Deny these commands:").grid(row=lastrow, sticky=W, columnspan=2)

        denied = {}
        for i in range(len(keys)):
            v = IntVar()
            c = Checkbutton(master,
                            text=keys[i],
                            anchor=W,
                            variable=v)
            c.grid(row=i/2+lastrow+1, column=i%2, sticky=W)
            v.set(keys[i] in self.initval[5])
            v.set(1)
            print keys[i],v.get()
            denied[keys[i]] = c, v


        print 
        return 
        
    def pickpath(self):
        pd = FileDialog.FileDialog(self.parent, title="Path")
        path = pd.go(dir_or_file="")
        if path:
            self.pathv.set(path)


class App(TkinterConfigList.App):

    def askval(self, initval=("*", "*", "*", "/", [], [])):
        d = PermDialog(self.frame,
                    title="What did you drink?",
                    initval=initval)


    def stringify(self, tup):
        return `tup`

    def prepare_for_save(self):
        stream = StringIO.StringIO()
        pprint.pprint(self.list, stream)
        s = stream.getvalue()
        stream.close()
        return "acllist = "+s+"\n"

TkinterConfigList.go(Frame=App, title="configure access", list=acllist,
                default_config_file=config_file)
