#!/usr/bin/python
# maybe you need to change the above line

# no license, no copyright, no warranties: placed into the Public Domain
# written by Marco Amrein in the year 2000

# pyFTPdrop 0.2.1
# ***************

# revision history:
#       0.2.0   initial public release
#       0.2.1   more informative FTP replies


import sys, socket, string, os, os.path, time, fnmatch, types
from stat import *
import timeout_socket
import SocketServer
from utils import *
from config import *

sys.path = sys.path+["/etc/pyftpd"]
# characters which must not appear in filenames
filename_deniedchars = map(chr, range(32))

exec("from "+perm_module+" import permcheck")

authmethods = []    
for i in authmodules:
    exec("import "+i)
    authmethods.append( (eval(i+".got_user"), eval(i+".got_pass")) )

def got_user(username, session, sessions): # session points to Session class
    last_deny_rt = 500, "", "", "", 0, 0
    last_grant_rt = 200, "", "", "", 0, 0
    last_rt = 500, "", "", "", 0, 0
    last = -1
    for i in authmethods:
        #rt = i[0](username, session, sessions)
        rt = n, r, u, g, l, c = i[0](username, session, sessions)
        if l == 0:
            last_deny_rt = rt
            last = 0
        elif l == 1:
            last_grant_rt = rt
            last = 1
        else:
            last_rt = rt
        if not c:
            break
    #now last is 1 for grant access, 0 for deny
    if last == 1:
        n, r, u, g, l, c = last_grant_rt
    elif last == 0:
        n, r, u, g, l, c = last_deny_rt
    else:
        n, r, u, g, l, c = last_rt
    return n, r, u, g, l

def got_pass(username, password, session, sessions):
    last_deny_rt = 500, "", 0, 0
    last_grant_rt = 200, "", 0, 0
    last_rt = 500, "", 0, 0
    last = 0
    for i in authmethods:
        rt = n, r, l, c = i[1](username, password, session, sessions)
        if l == 0:
            last_deny_rt = rt
            last = 0
        elif l == 1:
            last_grant_rt = rt
            last = 1
        else:
            last_rt = rt
        if not c:
            break
    #now last is 1 for grant access, 0 for deny
    if last == 1:
        n, r, l, c = last_grant_rt
    elif last == 0:
        n, r, l, c = last_deny_rt
    else:
        n, r, l, c = last_rt
    return n, r, l


# the main fun is here
class Session:

    def __init__(self, rfile, wfile, client_address):
    
        self.user = ""
        self.group = ""
        self.last_cmd_time = self.session_create_time = time.time()
        self.rfile = rfile
        self.wfile = wfile
        self.restpos = 0
        self.passive = 0
        self.ip = client_address[0]
        self.dataport = None
        opendebug("pyftpd["+self.ip+"]")
        self.replymessage(220, initial_msg)
        self.cwd = initial_wd

        self.cmddict = {
            "quit": self.cmd_quit,
            "syst": self.cmd_syst,
            "user": self.cmd_user,
            "pass": self.cmd_pass,
            "port": self.cmd_port,
            "stor": self.cmd_stor,
            "appe": self.cmd_appe,
            "dele": self.cmd_dele,
            "mkd" : self.cmd_mkd,
            "rmd" : self.cmd_rmd,
            "retr": self.cmd_retr,
            "rest": self.cmd_rest,
            "size": self.cmd_size,
            "list": self.cmd_list,
            "nlst": self.cmd_nlst,
            "pasv": self.cmd_pasv,
            "pwd" : self.cmd_pwd,
            "cwd" : self.cmd_cwd,
            "cdup": self.cmd_cdup,
            "type": self.cmd_dummy
            }
    
    
    def getpath(self, path):
        if os.path.isabs(path):
            return os.path.normpath(path)
        else:
            return os.path.normpath(os.path.join(self.cwd, path))

    def reply(self, x):
        self.wfile.write(x + "\r\n")
        debug("R:"+repr(x))
            
    def replymessage(self, n, x): # reply to the client, x is possibly tuple of lines
        if type(x) == types.StringType:
            self.reply(`n`+" "+x)
        else:
            for i in x[:-1]:
                self.reply(`n`+"-"+i)
            self.reply(`n`+" "+x[-1])

    def create_datasock(self):
        if not self.dataport:
            self.reply("425 what about a PORT command?")
            return
        try:
            sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s = t_socket(sock=sock, timeout=timeout_data)
            s.connect(self.ip, self.dataport)
            self.reply("150 dataconnection is up!")
            return s
        except socket.error:
            self.reply("425 your dataport sucks big time!")
            return None

    def cmd_quit(self,_):
        self.reply("221 Have a good one!")
        raise "session_exit"

    def cmd_user(self, username):
        n, r, self.user, self.group, self.logged = got_user(username, self, sessions)
        self.replymessage(n, r)

    def cmd_pass(self, password):
        n, r, self.logged = got_pass(self.user, password, self, sessions)
        self.replymessage(n, r)

    def cmd_dummy(self, _):
        self.reply("200 OK (in other words: ignored)")

    def cmd_syst(self, _):
        self.reply("215 UNIX Type: L8")

    def cmd_pwd(self, _):
        self.reply('257 "%s" is where you are' % self.cwd)

    def cmd_cdup(self,_):
        self.cmd_cwd(os.pardir)

    def cmd_cwd(self, path):
        if path:
            path = self.getpath(path)
            np = self.logged and permcheck(path, self.user, self.group, self.ip, "cwd") 
            if not np:
                self.reply("550 You are not allowed to")
                return
            try:
                os.chdir(np)
            except OSError:
                self.reply("550 You are not allowed to")
                return
            self.cwd = path
        self.reply("250 Ok, going there")

    def cmd_noop(self,_):
        self.reply("200 NOOPing")

    def cmd_pasv(self, _):
        self.passive = 1
        #self.reply("227 Entering Passive Mode (127,0,0,1,7,24)")
        self.reply("500 You're firewalled? What a pity...")

    def cmd_port(self, port_id):
        numstr = filter(lambda x: x in "0123456789,", port_id)
        parts = string.split(numstr,",")

        try:
            hi = int(parts[-2])
            lo = int(parts[-1])
            for v in [hi,lo]:
                if v < 0 or v > 255:
                    raise ValueError
        except IndexError:    
            self.reply("501 are you a hacker?")
            return
        except ValueError:
            self.reply("501 looks like nonsense to me...")
            return

        self.dataport = (hi << 8) + lo
        self.reply("230 Port is " + str(self.dataport)+ " (am ignoring specified IP for security)")

    def stor_or_appe(self, filename, comm, mode):
        if filename[0] == ".":
            self.reply("553 No dot files please!")
            return
        if filter(lambda x: x in filename_deniedchars, filename):
            self.reply("553 Bad characters in filename")
            return

        filepath = self.logged and permcheck(self.getpath(filename), self.user, self.group, self.ip, comm)
        if not filepath:
            self.reply("530 Permission denied")
            return
        r = "226 Phew, upload successfully completed"
        try:
            f = open(filepath, mode)
        except IOError:
            self.reply("553 File creation failed!")
            return

        sock = self.create_datasock()
        if not sock:
            f.close()
            return

        try:
            while 1:
                a = sock.recv(rbufsize)
                f.write(a)
                if len(a) == 0:
                    break
        except socket.error:
            r = "425 Socket error"
        except IOError:
            r = "451 Upload error"
        try:
            sock.close()
        except socket.error:
            pass
        f.close()
        self.reply(r)

    def cmd_stor(self, filename):
        self.stor_or_appe(filename, "stor", "wb")

    def cmd_appe(self, filename):
        self.stor_or_appe(filename, "appe", "ab")

    def cmd_dele(self, filename):
        filepath = self.logged and permcheck(self.getpath(filename), self.user, self.group, self.ip, "dele")
        if not filepath:
            self.reply("550 NO!")
            return
        try:
            os.unlink(filepath)
        except OSError:
            self.reply("550 You cannot do this, you know...")
            return
        self.reply("250 File eliminated")

    def cmd_mkd(self, dirname):
        dirname = self.getpath(dirname)
        filepath = self.logged and permcheck(dirname, self.user, self.group, self.ip, "mkd")
        if not filepath:
            self.reply("550 Permission denied.")
            return
        try:
            os.mkdir(filepath)
        except OSError:
            self.reply("550 You cannot do this, you know...")
            return
        self.reply('257 "%s" Directory created' % dirname)

    def cmd_rmd(self, dirname):
        filepath = self.logged and permcheck(self.getpath(dirname), self.user, self.group, self.ip, "rmd")
        if not filepath:
            self.reply("550 Permission denied.")
            return
        try:
            os.rmdir(filepath)
        except OSError:
            self.reply("550 You cannot do this, you know...")
            return
        self.reply("250 Directory removed")

    def cmd_rest(self, pos):
        try:
            self.restpos = long(pos)
            self.reply("350 Restarting. Are you happy?")
            return
        except ValueError:
            self.reply("530 Sorry.")


    def cmd_retr(self, path):
        path = self.logged and permcheck(self.getpath(path), self.user, self.group, self.ip, "retr")
        if not path:
            self.reply("530 Permission denied")
            return
        try:
            f = open(path,"rb")
            if self.restpos:
                f.seek(self.restpos)
        except (IOError, OSError):
            self.restpos = 0
            self.reply("553 File read failed!")
            return
        self.restpos = 0

        r = "226 Enjoy the file"
        sock = self.create_datasock()
        if not sock:
            f.close()
            return
        try:
            while 1:
                s = f.read(sbufsize)
                if not s:
                    break
                sock.send(s)
        except socket.error:
            r = "425 Socket error"
        except (IOError, OSError):
            r = "451 File read error"
        try:
            sock.close()
        except socket.error:
            r = "425 Socket error"
        f.close()
        self.reply(r)


    def cmd_size(self, path):
        path = self.logged and permcheck(self.getpath(path), self.user, self.group, self.ip, "size")
        if not path:
            self.reply("530 Permission denied")
            return
        try:
            size = os.stat(path)[ST_SIZE]
        except (OSError, IOError):
            self.reply("553 File read failed!")
            return
        self.reply("213 "+`size`)


    def cmd_nlst(self, path):
        self.cmd_list("-1 "+(path or ""))

    def cmd_list(self, args):

        args = string.split(args or "")
        sock = self.create_datasock()
        if not sock:
            return
        paths = []
        opts = ""
        for i in args:
            if i[0] == "-":
                opts = opts+i[1:]
            else:
                paths.append(i)
        if not paths:
            paths = [self.cwd]
            
        for path in paths:
            p = self.logged and permcheck(self.getpath(path), self.user, self.group, self.ip, "list")
            if not p:
                self.reply("550 Sorry")
                return
            if os.path.isfile(p) or (isdir(p) and 'd' in opts):
                lp = [p]
            elif isdir(p):
                try:
                    os.chdir(p)
                    lp = os.listdir(p)
                except OSError:
                    self.reply("550 I cannot")
                    return
            else:
                self.reply("550 Uh, what?")
                return
            if not '1' in opts: # long format
                r = []
                for i in lp:
                    try:
                        if os.path.islink(i):
                            dirflag = "l"
                        elif os.path.isdir(i):
                            dirflag = "d"
                        else:
                            dirflag = "-"
                        status = os.stat(i)
                        size = status[ST_SIZE]
                        user = str(status[ST_UID])
                        group = str(status[ST_GID])
                        t = status[ST_CTIME]
                        if t == -1:
                            t = 0
                        ctime = time.strftime("%b %d %Y",time.gmtime(t))
                        if isexec(i):
                            perm = "rwx"
                        else:
                            perm = "rw-"
                        rl = "%s%s%s%s  1 %10s %10s %10i %s %s\r\n" % \
                             (dirflag, perm,perm,perm, user, group, size, ctime, i)
                        r.append(rl)
                    except OSError:
                        pass
            else:
                r = map(lambda x: "%s\r\n" % x, lp)
            try:
                for i in r:
                    sock.send(i)
            except socket.error:
                break
        try:
            sock.close()
        except socket.error:
            pass

        self.reply("226 Wow, listing done")




    # parses the command and eventually calls the appropriate routine
    def docmd(self, cmd):
        debug("C:"+repr(cmd))
        # if the connection has broken... we have to shut down:
        if cmd == "":
            raise "session_exit"
        # filter suspicious chars first
        cmd2 = filter(lambda x: ord(x) >= 32,cmd)
        lcmd2 = string.split(cmd2, None, 1)
        command = string.lower(lcmd2[0])
        if len(lcmd2) > 1:
            args = string.strip(lcmd2[1])
        else:
            args = None

        u = self.user or "-"
        ip = self.ip or "-"
        if command == "pass":
            c = "PASS ****"
        else:
            c = cmd2
        log.log("%s: %s@%s : %s" % (time.ctime(time.time()), u, ip, c))
        if self.cmddict.has_key(command):
            return self.cmddict[command](args)
        else:
            self.reply("500 I'm gonna ignore this command... maybe later...")
        return

    def loop(self):
        while 1:
            try:
                self.last_cmd_time = time.time()
                self.docmd(self.rfile.readline())
            except timeout_socket.Timeout:
                try:
                    self.reply("421 timeout")
                    break
                except ("session_exit", socket.error, timeout_socket.Timeout):
                    break
            except ("session_exit", socket.error):
                break
        debug("Connection closed.")


def watchdog():
    while 1:
        time.sleep(2)
        cur_time = time.time()
        print sessions
        for i in range(len(sessions)):
            print sessions[i].ip
        print



# the main routine
# ----------------


class NoneClass:
    pass

try:
    import thread
    threading = 1
except:
    threading = 0

forking =  hasattr(os, "fork")

if threading:
    mixin = SocketServer.ThreadingMixIn
elif forking:
    mixin = SocketServer.ForkingMixIn
else:
    mixin = NoneClass

sessions = []

class t_socket(timeout_socket.timeout_socket):
    def flush(self): # TCPSerevr needs this
        pass
    def makefile(self, flags="r", buffsize=-1): # makefile lacks attributes
        # Just return ourself - watch out for multiple close(), and
        # provide read and readline methods expected by makefile result below.
        return self
    def write(self, data):
        self.send(data)
    def close(self):
        self.s.close()
    
        
class TCPServer(mixin, SocketServer.TCPServer):
    def server_bind(self):
        """Called by constructor to bind the socket.
        """
        self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.socket.bind(self.server_address)

    def get_request(self):
        """Get the request and client address from the socket.
        """
        conn, adr = self.socket.accept()
        conn = t_socket(sock = conn, timeout=timeout_session)
        return conn, adr


class FTPServer(SocketServer.StreamRequestHandler):
    def handle(self):
        session = Session(self.rfile, self.wfile, self.client_address)
        sessions.append(session)
        session.loop()
        sessions.remove(session)
        del(session)


log = Log(logfile)

address = ('', port)


server = TCPServer(address, FTPServer)

#thread.start_new_thread(watchdog, ())

server.serve_forever()
